// Common/StdOutStream.cpp

#include "StdAfx.h"

#include "StdOutStream.h"

CStdOutStream  g_StdOut;

CStdOutStream ::CStdOutStream ()
{
	m_lpOutBuf = (char*)::GlobalAlloc(GMEM_FIXED, 4096);
	ReSet();
}

CStdOutStream ::~CStdOutStream ()
{
	::GlobalFree(m_lpOutBuf);
}


CStdOutStream & CStdOutStream ::operator<<(CStdOutStream & (*aFunction)(CStdOutStream  &))
{
  (*aFunction)(*this);    
  return *this;
}

CStdOutStream & endl(CStdOutStream & anOut)
{
  return anOut << "\n";
}

CStdOutStream & CStdOutStream::operator<<(const char *aChars)
{
	char* lpszText = (char*)_alloca(strlen(aChars) * 2);
	char* p = lpszText;
	while (*aChars)
	{
		// s"\r""\r\n"ɏC
		if (*aChars == '\n')
		{
			*p = '\r';
			++p;
		}
		*p = *aChars;
		++p;
		++aChars;
	}
	*p = '\0';
	OutProgress(lpszText);
	return *this;
}

CStdOutStream & CStdOutStream::operator<<(char aChar)
{
	char lpszText[3];
	if (aChar == '\n')
	{
		lpszText[0] = '\r';
		lpszText[1] = '\n';
		lpszText[2] = '\0';
	}
	else
	{
		lpszText[0] = aChar;
		lpszText[1] = '\0';
	}
	OutProgress(lpszText);
	return *this;
}

CStdOutStream & CStdOutStream::operator<<(int aNumber)
{
	char lpszText[16];
	sprintf(lpszText, "%d", aNumber);
	OutProgress(lpszText);
	return *this;
}

CStdOutStream & CStdOutStream::operator<<(UINT32 aNumber)
{
	char lpszText[16];
	sprintf(lpszText, "%u", aNumber);
	OutProgress(lpszText);
	return *this;
}

CStdOutStream & CStdOutStream::operator<<(UINT64 aNumber)
{
	char lpszText[32];
	sprintf(lpszText, "%I64u", aNumber);
	OutProgress(lpszText);
	return *this;
}

// i󋵂o
void CStdOutStream::OutProgress(const char *lpszText)
{
	int nStrLen = strlen(lpszText);
	if (m_dwMaxBuf <= m_dwBufSize + nStrLen)
	{
		m_dwMaxBuf += 4096;
		m_lpOutBuf = (char*)::GlobalReAlloc(m_lpOutBuf, m_dwMaxBuf, GMEM_MOVEABLE);
	}
	memcpy(m_lpOutBuf + m_dwBufSize, lpszText, nStrLen + 1);
	m_dwBufSize += nStrLen;
/*
	// _CAOɏo
	if (m_hOutWnd && !m_bHide)
		::SendMessage(GetOutDialogHandle(), WM_OUTPUT_PROGRESS, (WPARAM)nBack, (LPARAM)lpszText);

	if (m_nMode >= 0)
	{
		// R[obN֐ɏo
		if (m_lpArcProc)
		{
			if (m_lpArcProc(m_hOwnerWnd, wm_arcextract, m_nMode, m_nMode == 2 ? NULL : &m_eiData) == FALSE)
				::PostMessage(GetOutDialogHandle(), WM_COMMAND, IDCANCEL, 0);
		}
		// I[i[EBhEɏo
		else if (m_hOwnerWnd)
		{
			if (::SendMessage(m_hOwnerWnd, wm_arcextract, (WPARAM)m_nMode, m_nMode == 2 ? 0 : (LPARAM)&m_eiData.exinfo) != FALSE)
				::PostMessage(GetOutDialogHandle(), WM_COMMAND, IDCANCEL, 0);
		}
		m_nMode = -1;
	}*/
}


// oϐ
void CStdOutStream::ReSet()
{
	m_pDlgProgress = NULL;
	m_hThread = NULL;
	m_lpOutBuf = (char*)::GlobalReAlloc(m_lpOutBuf, 4096, GMEM_MOVEABLE);
	m_dwBufSize = 0;
	m_dwMaxBuf = 4096;
//	::ZeroMemory(&m_eiData, sizeof(EXTRACTINGINFOEX));
}

// o͂Rs[
// lpCopyBufNULL̎͏o̓obt@̃|C^̂Ԃ
LPCSTR CStdOutStream::CopyBuf(LPSTR lpCopyBuf, DWORD dwBufSize)
{
	if (lpCopyBuf == NULL)
		return m_lpOutBuf;
	strncpy(lpCopyBuf, m_lpOutBuf, dwBufSize);
	lpCopyBuf[dwBufSize - 1] = '\0';
	return lpCopyBuf;
}

